//  2001
//    "  "
//  

//   (   conjurate-gradients.hpp),    
//    .

#include <conjurate-gradients.hpp>
#include <crammer.hpp>
#include <gauss.hpp>

//  !=0       .
static inline int vector_zero( vector& r) {
uint i;
for (i=0;i<r.getn();i++)
	if (r.get(i)!=0) return 0;
	
	return 1;
	
}

vector* cnj_grad_algorithm(const matrix &A, const vector& B) {
int k, n = A.getn();       // n*n
vector* x = new vector(n);
vector r_prev(n);
vector r_next(n);
vector p(n);
real bk, a=0;
uint loops = 0;

	//       
	if ( matrix_invert(A)!=A) return NULL;
	
	//  
	x->fill(0);
	for (k=0;k<n;k++) {
		loops++;
		r_prev = r_next;
		if (k==0) { //      a
			r_next = B - (A* (*x)); 
		} else r_next = r_prev - (A*p)*a;
			
		if ( vector_zero( r_next)) {
			goto finish;	
		} else {
			if (k==0) {
				p = r_next;
			} else {
				bk = ( r_next*r_next)/(r_prev*r_prev);
				p = r_next + p*bk;
			}
			a = (r_next*r_next)/((A*p)*p);
			*x = (*x) + p*a;
		}
	}
	
	finish:
	cout << "Loops in Conjurate gradients algorithm: "<<loops << endl;	
	return x;
	
}

#define DIM 20
#define SET_A_VALUES \
	for (i=0;i<DIM;i++) \
		for (j=0;j<DIM;j++) { \
			if (i==j) A.set( i, j, 6); \
			else A.set( i, j, 4); \
		}

#define SET_B_VALUES \
	for (i=0;i<DIM;i++) { \
		B.set( i, 1); \
	}

void test_cg() {
	matrix A(DIM);
	vector B(DIM);
	vector *x;
	uint i,j;

	// Put the matrix and vector values
	SET_A_VALUES;
	SET_B_VALUES;
			
	cout << "A: "<<endl;
	cout << A << endl << endl;

	cout << "B: "<<endl;
	cout << B << endl;
	cout << endl;

	// CONJURATE GRADIENTS
	cout << endl;

	cout << "    " << endl;

	x = cnj_grad_algorithm(A, B);
	cout << "X: \n[" <<  *x << "]\n";
	delete x;
	cout << endl;

	cout << "  Gauss: " << endl;
	x = gauss_algorithm(A, B, 1);
	cout << "X: \n" << *x << endl;
	delete x;
}
