//  2001
//    "  "
//  

// Header   matrix.cpp

#ifndef MATRIX_H
# define MATRIX_H

#include <real.hpp>
#include <vector.hpp>

class matrix
{
public:
	matrix(const uint);
	~matrix();
	matrix(const matrix &);
	matrix();

//functions
        uint getn() const;
        real get(const uint i,const uint j) const;
		real norm1() const;
        void set(const uint i,const uint j,real val);
        void fill(const real fl);
        void diagfill(const real fl);
		void swaplines(const int line1, const int line2);

//operators
        bool operator== (const matrix&) const;
        bool operator!= (const matrix&) const;
        matrix operator+ (const matrix&) const;
        matrix operator- (const matrix&) const;
        matrix & operator= (const matrix&);
        matrix operator*(const real&) const;
        matrix operator*(const matrix&) const;
        vector operator*(const vector&) const;
        friend ostream & operator<< (ostream& ,const matrix &);

private:
        void direct_set(const uint i,real val){elem[ i]=val;}
        real direct_get(const uint ij) const {return elem[ ij];}

        uint itsn;
        real * elem;
		int * line_index;
};

//diloseis synartisewn
matrix *matrix_step(uint a,uint b,const matrix & A);
real matrix_det (const matrix & A);
matrix matrix_invert(const matrix & A);
matrix matrix_reverse(const matrix & A);

#endif
