//  2001
//    "  "
//  

#include "real.hpp"

//   'real':
//   compile   -DUSE_REAL     .
//       real      
//      float.        
//    (double),    float.

//    defined  FLOAT  float   DOUBLE_FLOAT 
// double,   double  long double     compiler.

#ifdef USE_REAL

// returns the real's size
FLOAT real::value() const
{
	return val;
}

inline void real::set(FLOAT value)
{
	val = value;
}


// constructor
real::real(const int n)
{
	val = n;
}

// constructor
real::real(const uint n)
{
	val = n;
}

// constructor
real::real(const FLOAT n)
{
	val = n;
}

// constructor
real::real(const DOUBLE_FLOAT n)
{
	val = static_cast < FLOAT > (n);
}

// constructor
real::real()
{
}

// print a real
ostream & operator << (ostream & output, const real & A) {
	output << A.val;
	return output;
}

// constructor
real::real(const real & rhs)
{
	val = rhs.val;
}

// real + real
real real::operator + (const real & rhs) const {

	real B;
	B.val =
	    static_cast < DOUBLE_FLOAT > (static_cast < DOUBLE_FLOAT >
					  (val) + static_cast <
					  DOUBLE_FLOAT > (rhs.val));
	return B;
}

// real - real 
real real::operator - (const real & rhs) const
{

	real B;
	B.val =
	    static_cast < DOUBLE_FLOAT > (static_cast < DOUBLE_FLOAT >
					  (val) - static_cast <
					  DOUBLE_FLOAT > (rhs.val));
	return B;
}

// real = other_real
real & real::operator = (const real & rhs) {
	if (this == &rhs)
		return *this;

	val = rhs.val;
	return *this;

}

// real != int
bool real::operator != (const real & rhs)
const {
	return (rhs.val != val);
}
// real == real 

bool real::operator == (const real & rhs) const {
	return (rhs.val == val);
}

// real > real
bool real::operator > (const real & rhs) const {
	return (val > rhs.val);
}


// real < real 
bool real::operator < (const real & rhs) const
{
	return (val < rhs.val);
}

// real * real
real real::operator * (const real & rhs) const {
	real B;
	B.val =
	    static_cast < DOUBLE_FLOAT > (static_cast < DOUBLE_FLOAT >
					  (val) * static_cast <
					  DOUBLE_FLOAT > (rhs.val));
	return B;
}

// real / real 
real real::operator / (const real & rhs) const
{
	real B;

	B.val =
	    static_cast < DOUBLE_FLOAT > (static_cast < DOUBLE_FLOAT >
					  (val) / static_cast <
					  DOUBLE_FLOAT > (rhs.val));
	return B;
}

#endif
