//  2001
//    "  "
//  

// Header   vector.cpp


#ifndef VECTOR_H
# define VECTOR_H

#include <real.hpp>

class vector
{
public:
	vector(const uint);
	vector();
	~vector();
	vector(const vector &);

//functions
        uint getn() const;
        real get(const uint i) const;
        void set(const uint i, real val);
        void fill(const real fl);
		void swaplines(const int line1, const int line2);
		real norm1() const;
		real norm() const;
//operators
        vector operator+ (const vector&) const;
        vector operator- (const vector&) const;
        vector & operator= (const vector&);
        vector operator*(const real) const;
        real operator*(const vector&) const;
        friend ostream & operator<< (ostream& ,const vector &);

private:
	// line_index is not kept, since it's too
	// easy to swap lines here.
        uint itsn;
        real * elem;
};

# ifndef NULL_OK
  extern vector _NULL_VECTOR;
# endif

#endif
